/*
 * file_arg.c        -	This file is part of the MakeGENerator program, a
 *			programmers' utility for automatic generation of
 *			makefiles.
 *
 * Copyright (C) 1997 Gil-ad Madar
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *   Author: Gil-ad Madar
 *   e-mail: gil-ad@inter.net.il
 */

#define	 FILE_ARG__C
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "globals.h"
#include "hash.h"
#include "vars.h"
#include "file_arg.h"
/*--------------------------------------------------------------------------*/
void	file_args_vec_init( void )
{
	int	i;


	file_args_num = 1;
	memset( (void *)file_args_vec,  '\0', MAX_FILES * sizeof(FILE_ARGS) );
	memset( (void *)file_args_path, '\0', MAX_FILE_ARGS_PATHES_LEN  );
	file_args_path_ptr = &file_args_path[ 0 ];
	for ( i = 0; i < MAX_FILES; i++ )
		file_args_vec[ i ].path = file_args_path_ptr;
	file_args_path_ptr += 1;
}
/*--------------------------------------------------------------------------*/
unsigned short	file_args_vec_insert(	char	*filename,
					char	*path	)
{
	if ( file_args_num >= MAX_FILES )
	{
		fprintf(stderr,
			"\nCan not insert file %s from directory \"%s\" %s",
			filename,
			path,
			"into file_args_vec[]. Ignored" );
		return 1;
	}
	file_args_vec[ file_args_num ].path = path;
	strcpy( file_args_vec[ file_args_num ].filename, filename );
	file_args_num++;
	return 0;
}
/*--------------------------------------------------------------------------*/
char	*file_args_path_insert( char	*path )
{
	char	*ret_ptr = file_args_path_ptr;
	char	*tmp_ptr;
	int	i;


	if ( path == NULL )
	{
		fprintf(stderr,
			"\nSource path is illegal - Path is NULL. Ignored." );
		return NULL;
	}

	if ( strlen( path ) == 0 )
		return file_args_path;

	i = 1;
	while (	i < MAX_FILE_ARGS_PATHES_LEN )
	{
		tmp_ptr = file_args_path + i;
		if ( strcmp( path, tmp_ptr ) == 0 )
			return tmp_ptr;
		i += strlen( tmp_ptr );
		i++;
		if ( *tmp_ptr == '\0' )
			break;
	}

	if ( (	file_args_path_ptr +
		strlen( path ) +
		1 - file_args_path ) > MAX_FILE_ARGS_PATHES_LEN )
	{
		fprintf(stderr,
			"\nSource pathes array is full. Path %s ignored.",
			path );
		return NULL;
	}

	strcat(	file_args_path_ptr, path );
	file_args_path_ptr += strlen( path );
	file_args_path_ptr += 1;

	return	ret_ptr;
}
/*--------------------------------------------------------------------------*/
unsigned short	file_args_get_name(	int	entry,
					char	*filename)
{
	if ( entry > file_args_num )
	{
		fprintf(stderr,
			"\n%s\n%s%d .",
			"Illegal entry number sent to file_args_get_name.",
			"Entry number : ",
			entry );
		return 1;
	}
	if ( filename == NULL )
	{
		fprintf(stderr,
			"\nBad %s parameter filename was sent to routine %s.",
			"(NULL)",
			"file_args_get_name" );
		return 1;
	}

	if ( file_args_vec[ entry ].path == NULL )
	{
		fprintf(stderr,
			"\nfile_args_vec[ entry ].path == NULL in routine %s.",
			"file_args_get_name" );
		return 1;
	}
	if ( file_args_vec[ entry ].path[ 0 ] == '\0' )
		strcpy( filename, file_args_vec[ entry ].filename );
	else
	{
		strcpy( filename, file_args_vec[ entry ].path );
		strcat( filename, PATH_SEPERATOR_STRING );
		strcat( filename, file_args_vec[ entry ].filename );
	}
	return 0;
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

