/*
 * globals.h         -	This file is part of the MakeGENerator program, a
 *			programmers' utility for automatic generation of
 *			makefiles.
 *
 * Copyright (C) 1997 Gil-ad Madar
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *   Author: Gil-ad Madar
 *   e-mail: gil-ad@inter.net.il
 */

#ifndef GLOBALS__H
#define GLOBALS__H

/*--------------------------------------------------------------------------*/
#define	MAKEGEN_FULL_VERSION
/*--------------------------------------------------------------------------*/

#ifdef	BORLANDC_DOS_VERSION
#undef	BORLANDC_WINDOWS_VERSION
#undef	HIGHC_DOS_VERSION
#undef	GNUC_LINUX_VERSION
#undef	MGEN_CASE_SENSITIVE_PATH
#endif

#ifdef	BORLANDC_WINDOWS_VERSION
#undef	BORLANDC_DOS_VERSION
#undef	HIGHC_DOS_VERSION
#undef	GNUC_LINUX_VERSION
#undef	MGEN_CASE_SENSITIVE_PATH
#endif

#ifdef	HIGHC_DOS_VERSION
#undef	BORLANDC_DOS_VERSION
#undef	BORLANDC_WINDOWS_VERSION
#undef	GNUC_LINUX_VERSION
#undef	MGEN_CASE_SENSITIVE_PATH

#define	opendir		_opendir
#define	closedir	_closedir
#define	readdir		_readdir
#define	rewinddir	_rewinddir
#define	__MSDOS__	_MSDOS

#endif

#ifdef	GNUC_LINUX_VERSION
#undef	HIGHC_DOS_VERSION
#undef	BORLANDC_DOS_VERSION
#undef	BORLANDC_WINDOWS_VERSION
#define	MGEN_CASE_SENSITIVE_PATH
#endif

#ifndef	BORLANDC_DOS_VERSION
#ifndef	BORLANDC_WINDOWS_VERSION
#ifndef	HIGHC_DOS_VERSION
#ifndef	GNUC_LINUX_VERSION
#error  You must define one of the following: BORLANDC_DOS_VERSION or BORLANDC_WINDOWS_VERSION or HIGHC_DOS_VERSION or GNUC_LINUX_VERSION
#endif
#endif
#endif
#endif
/*--------------------------------------------------------------------------*/
#ifdef	MAKEGEN_FULL_VERSION
#define MAKEGEN_VER_CHAR			'F'
#else
#define MAKEGEN_VER_CHAR			'P'
#endif
/*--------------------------------------------------------------------------*/
#ifndef	GNUC_LINUX_VERSION
#define MAX_FILE_NAME				15
#define PATH_SEPERATOR_CHAR			'\\'
#define PATH_SEPERATOR_STRING			"\\"
#else
#define MAX_FILE_NAME				255
#define PATH_SEPERATOR_CHAR			'/'
#define PATH_SEPERATOR_STRING			"/"
#endif
#ifndef MAX_FILES
#error	MAX_FILES is undefined!
#endif
#define MAX_PROFILE_LINE_LENGTH			1024
#define PATH_MAX_LEN				1024
#define MAX_LIB_CMD_LINE			MAX_PROFILE_LINE_LENGTH
#define MAX_FILES_SELECTION			MAX_PROFILE_LINE_LENGTH
#define MAX_CMD_LINE				160

#define TWO_SPACES_DEPENDENCY_SEPERATOR		"  "
#define NEWLINE_TAB_TAB_DEPENDENCY_SEPERATOR	"\n\t\t"
/*--------------------------------------------------------------------------*/
#define	MMAKER_OK				0
#define MMAKER_NOT_OK				1
/*--------------------------------------------------------------------------*/
#define	BASE_WD_IS_UWD				51
#define	BASE_WD_IS_FULL				52
/*--------------------------------------------------------------------------*/
#define	BAD_PARAMETERS				-1
#define	MEMORY_ALLOCATION_FAILURE		-2
#define	UNINITIALIZED_ELEMENT			-3
#define	FILE_OPENNING_FAILED			-5
#define ELEMENT_ALREADY_PRESENT			-6
#define NOT_ENOUGH_PARAMS			-9
#define NO_PATH_PARAM				-10
#define BAD_PATH_PARAM				-11
#define CAN_NOT_OPEN_PATH_FILE			-12
#define PATH_FILE_IS_EMPTY			-13
#define BAD_LIB_PARAM				-14
#define BAD_LBC_PARAM				-15
#define	BAD_COMPILER_PARAM			-16
#define NO_PROFILE_PARAM			-17
#define BAD_PROFILE_PARAM			-18
/*--------------------------------------------------------------------------*/
#define PATH_INDEX_HERE				-1
#define PATH_INDEX_NONE				-2
/*--------------------------------------------------------------------------*/
#ifdef	BORLANDC_WINDOWS_VERSION
#include <windows.h>
#endif
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/

#endif		/* #ifndef GLOBALS__H					    */

