/*
 * macros.h          -	This file is part of the MakeGENerator program, a
 *			programmers' utility for automatic generation of
 *			makefiles.
 *
 * Copyright (C) 1997 Gil-ad Madar
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *   Author: Gil-ad Madar
 *   e-mail: gil-ad@inter.net.il
 */

#ifndef MACROS__H
#define MACROS__H

/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#define	MACROS_FILENAME_PATTERN		"\\filename"
#define	MACROS_FILENAME1_PATTERN	"\\fn"
#define	MACROS_BASENAME_PATTERN		"\\basename"
#define	MACROS_BASENAME1_PATTERN	"\\bn"
#define	MACROS_EXTENTION_PATTERN	"\\extention"
#define	MACROS_EXTENTION1_PATTERN	"\\xt"
#define	MACROS_NEWLINE_PATTERN		"\\newline"
#define	MACROS_NEWLINE1_PATTERN		"\\n"
#define	MACROS_BACKSLASH_PATTERN	"\\backslash"
#define	MACROS_BACKSLASH1_PATTERN	"\\bs"
/*--------------------------------------------------------------------------*/
typedef struct
{
	char	filename [ _MAX_PATH ];
	char	basename [ 15 ];
	char	extention[ 15 ];
	char	newline	 [ 5  ];
}	COMPILE_MACROS;
/*--------------------------------------------------------------------------*/
	int	macros_match(	char		*pattern,
				char		*str,
				unsigned int	max_len	);
/*--------------------------------------------------------------------------*/
	void	macros_expand_compile_macros(	char		*str_in,
						char		*str_out,
						COMPILE_MACROS	*mptr	);
/*--------------------------------------------------------------------------*/
	int	macros_compute_compile_macros(	char		*filename,
						COMPILE_MACROS	*mptr	);
/*--------------------------------------------------------------------------*/
	int	macros_expandable_in_string_count( char	*str_in );
/*--------------------------------------------------------------------------*/

#endif		/* #ifndef MACROS__H															 */

