/*
 * maker.c           -	This file is part of the MakeGENerator program, a
 *			programmers' utility for automatic generation of
 *			makefiles.
 *
 * Copyright (C) 1997 Gil-ad Madar
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *   Author: Gil-ad Madar
 *   e-mail: gil-ad@inter.net.il
 */

/*--------------------------------------------------------------------------*/
#include "globals.h"
/*--------------------------------------------------------------------------*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <dirent.h>

#ifdef	GNUC_LINUX_VERSION
#include <time.h>
#else
#include <dos.h>
#include <direct.h>
#include <conio.h>
#endif		/* #ifdef	GNUC_LINUX_VERSION	*/

#include "hash.h"
#include "options.h"
#include "maker.h"
#include "vars.h"
#include "macros.h"
#include "xxmacros.h"
#include "xxpathes.h"
#include "file_arg.h"
/*--------------------------------------------------------------------------*/
#define	MAKER_PRINT_NEWLINE_IN_MAKEFILE	\
	fprintf( makefile , "\n#" );
#define	MAKER_PRINT_LINE_IN_MAKEFILE	\
	fprintf( makefile , "\n#--------------------------------------------------------------------------");
	extern PATH_ENTRY	xxxx_pathes[];
	extern int		xxxx_pathes_counter;
/*--------------------------------------------------------------------------*/
/* 	Static variables:						    */
/*--------------------------------------------------------------------------*/
	static	FILE		*makefile;
	static	char		compiler_out[ MAX_CMD_LINE ];
/*--------------------------------------------------------------------------*/
void	maker_print_extra_extention_generic(	unsigned short	i,
						char		*format );
/*--------------------------------------------------------------------------*/
char	*current_directory(char *cur_dir)
{
	getcwd( cur_dir, _MAX_PATH );
	return(cur_dir);
}
/*--------------------------------------------------------------------------*/
char	*lower_case_string(char	*str)
{
	int	length, i;

	length = strlen( str );
	for (i = 0; i < length; i++)
		str[i] = tolower(str[i]);

	return	str;
}
/*--------------------------------------------------------------------------*/
void	maker_print_user_header( void )
{
  	FILE		*fptr;
	char		line[256]="";
				       
	if ( options_user_header_filename[ 0 ] == '\0' )
		return;
	fptr = fopen( options_user_header_filename, "rt" );
	if ( fptr == NULL )
	{
	  	printf( "\nCan't open user header file named %s. Ignoring.",
			options_user_header_filename );
		return;
	}

	fprintf( makefile , "\n# User's Header file :\n" );
	while ( fgets( line, 255, fptr ) != NULL )
		fputs( line, makefile );

	fprintf( makefile , "\n#--------------------------------------------------------------------------");
	fprintf( makefile , "\n#" );
	fclose( fptr );
}
/*--------------------------------------------------------------------------*/
void	maker_print_user_footer( void )
{
  	FILE		*fptr;
	char		line[256]="";

	if ( options_user_footer_filename[ 0 ] == '\0' )
		return;
	fptr = fopen( options_user_footer_filename, "rt" );
	if ( fptr == NULL )
	{
	  	printf( "\nCan't open user footer file named %s. Ignoring.",
			options_user_footer_filename );
		return;
	}

	fprintf( makefile , "\n# User's Footer file :\n" );
	while ( fgets( line, 255, fptr ) != NULL )
		fputs( line, makefile );

	fprintf( makefile , "\n#--------------------------------------------------------------------------");
	fclose( fptr );
}
/*--------------------------------------------------------------------------*/
void	maker_dependency_extra_extention( unsigned short	i  )
{
  	char		*target;
	char		*source;
	char		*fnptr;
	char		source_pattern[ _MAX_EXT + 1 ] = "*.";
	char		a_filename[ _MAX_PATH ];
	char		*end_of_p;
	DIR		*dirp;
	struct dirent	*dp;

	if ( i >= 10 )
		printf("\nParameter for extra extention # should be between 0 and 9");

	target	= extra_extentions[ i ].target;
	source	= extra_extentions[ i ].source;
	strcat( source_pattern, source );

	
	if ( (dirp = opendir( "." )) == NULL )
	{
		fprintf( stderr, "\nCannot open \".\" directory" );
		return;
	}

	while ( (dp = readdir( dirp )) != NULL )
	{
		end_of_p = source_pattern + strlen( source_pattern ) - 1;
		while ( *end_of_p != '.' )
			end_of_p--;
		end_of_p++;
#ifndef	MGEN_CASE_SENSITIVE_PATH
		if ( options_ext_match( lower_case_string( dp->d_name ),
#else
		if ( options_ext_match( dp->d_name,
#endif
							end_of_p ) == 0 )
		{
			strcpy(	a_filename, dp->d_name );
			fnptr = strtok( a_filename, "." );
			fprintf(makefile , 
				"\n\t\t%s%c%s.%s\t\\" , 
				compiler_output_directory,
				PATH_SEPERATOR_CHAR,
				fnptr,
				target );
		}
	}
	closedir( dirp );
}
/*--------------------------------------------------------------------------*/
void	maker_dependency_extra_extentions( void )
{
	unsigned short	i;
  	
	for ( i = 0; i < 10; i++ )
	{
	  	if (	(extra_extentions[ i ].target[ 0 ] != '\0')	&&
			(extra_extentions[ i ].source[ 0 ] != '\0')	&&
			(extra_extentions[ i ].command_line[ 0 ] != '\0')	)
			maker_dependency_extra_extention( i );
	}
}
/*--------------------------------------------------------------------------*/
void	maker_handle_extra_extention( unsigned short	i  )
{
  	char		*target;
	char		*source;
	char		*command_line;
	char		*fnptr;
	char		source_pattern[ _MAX_EXT + 1 ] = "*.";
	char		a_filename[ _MAX_PATH ];
	char		*end_of_p;
	DIR		*dirp;
	struct dirent	*dp;
	char		a_filename_for_macros_expansion[ MAX_FILE_NAME ];
	COMPILE_MACROS	m;
	unsigned long	macros_present_in_command_line;

	if ( i >= 10 )
		printf("\nParameter for extra extention # should be between 0 and 9");

	target		= extra_extentions[ i ].target;
	source		= extra_extentions[ i ].source;
	command_line	= extra_extentions[ i ].command_line;
	strcat( source_pattern, source );

	macros_present_in_command_line = macros_expandable_in_string_count( command_line );

	if ( (dirp = opendir( "." )) == NULL )
	{
		fprintf( stderr, "\nCannot open \".\" directory" );
		return;
	}

	while ( (dp = readdir( dirp )) != NULL )
	{
		end_of_p = source_pattern + strlen( source_pattern ) - 1;
		while ( *end_of_p != '.' )
			end_of_p--;
		end_of_p++;
#ifndef	MGEN_CASE_SENSITIVE_PATH
		if ( options_ext_match( lower_case_string( dp->d_name ),
#else
		if ( options_ext_match( dp->d_name,
#endif
							end_of_p ) == 0 )
		{
			strcpy(	a_filename, dp->d_name );
			fnptr = strtok( a_filename, "." );


			fprintf(makefile , 
				"\n%s%c%s.%s : \\" , 
				compiler_output_directory,
				PATH_SEPERATOR_CHAR,
				fnptr,
				target );
			if ( maker_control_rel == True )
				fprintf(makefile , 
					"\n\t\t%s.%s",
					fnptr,
					source );
			else
				fprintf(makefile , 
					"\n\t\t%s%c%s.%s",
					compiler_run_directory,
					PATH_SEPERATOR_CHAR,
					fnptr,
					source );
			fprintf(makefile,
				"\n\tcd %s",
				compiler_run_directory );
			if ( macros_present_in_command_line == 0 )
			{
				fprintf(makefile,
					"\n\t%s %s.%s",
					command_line,
					fnptr,
					source );
			}
			else
			{
				sprintf(a_filename_for_macros_expansion,
					"%s.%s",
					fnptr,
					source );
				memset(	compiler_out, 0, MAX_CMD_LINE );
				macros_compute_compile_macros( a_filename_for_macros_expansion, &m );
				macros_expand_compile_macros( command_line, compiler_out, &m );
				fprintf(makefile,
					"\n\t%s",
					compiler_out );
			}
			fprintf(makefile, "\n#");
			fprintf(makefile, "\n#\n");
		}
	}
	closedir( dirp );
}
/*--------------------------------------------------------------------------*/
void	maker_handle_extra_extentions( void )
{
	unsigned short	i;
  	
	for ( i = 0; i < 10; i++ )
	{
	  	if (	(extra_extentions[ i ].target[ 0 ] != '\0')	&&
			(extra_extentions[ i ].source[ 0 ] != '\0')	&&
			(extra_extentions[ i ].command_line[ 0 ] != '\0')	)
			maker_handle_extra_extention( i );
	}
}
/*--------------------------------------------------------------------------*/
void	maker_print_extra_extentions( void )
{
	unsigned short	i;
  	
	for ( i = 0; i < 10; i++ )
	{
	  	if (	(extra_extentions[ i ].target[ 0 ] != '\0')	&&
			(extra_extentions[ i ].source[ 0 ] != '\0')	&&
			(extra_extentions[ i ].command_line[ 0 ] != '\0')	)
			maker_print_extra_extention_generic( i,"\n#\t\t%s%c%s");
	}
}
/*--------------------------------------------------------------------------*/
int	maker_file(	HASH_TABLE	*h,
			HASH_ELEMENT 	*e)
{
	char		search_for[16]="#include";
	char		line[256]="";
	char		son_full_path_file_name[256];
	char		*found_position_of_include;
	char		left_quote;
	char		right_quote;
	char		*file_name_ptr;
	FILE		*f;
	char		*c_index;
	int		continue_flag;
	unsigned short	line_counter = 0;
	HASH_ELEMENT	*tmp_el;
	char 		full_path_file_name[ _MAX_PATH ];
	int		*path_index_ptr;

	if (	( e == NULL ) 					||
		( e->rest.local.full_filename_ptr == NULL )	||
		( *(e->rest.local.full_filename_ptr) == PATH_INDEX_NONE ) ||
		(h->type != LOCAL_HASH_TABLE)			)
		return	BAD_PARAMETERS;

	path_index_ptr = e->rest.local.full_filename_ptr;
	if ( *path_index_ptr != PATH_INDEX_HERE )
		sprintf(full_path_file_name, 
			"%s%c%s",
			xxxx_pathes[ *path_index_ptr ].true_name,
			PATH_SEPERATOR_CHAR,
			e->filename );
	else
		sprintf(full_path_file_name, 
			"%s",
			e->filename );
	f = fopen( full_path_file_name , "rt");
	if ( f == NULL )
		return	FILE_OPENNING_FAILED;

	while (	(!maker_max_lines ? 1 : ( line_counter++ < maker_max_lines ) )	&&
		( NULL != fgets( line , 256 - 1 , f ) )				)
	{
		continue_flag = 0;
		found_position_of_include = (char *)strstr( line, search_for);
		for (c_index = line; c_index < found_position_of_include; c_index++)
			if ( !isspace( c_index[0] ) )
			{
				continue_flag = 1;
				break;
			}
		if (continue_flag == 1)
			continue;
		if ( found_position_of_include == NULL )
			continue;

		/* advance found_position_of_include to the first character */
		/* after the #include statement				    */
		found_position_of_include += strlen( search_for );

		while ( ( *found_position_of_include != '\0'  ) &&
			( isspace (*found_position_of_include)))
			found_position_of_include++;

		if (	( found_position_of_include == NULL)	||
			(*found_position_of_include == '\0')	)
			continue;
		if (	(*found_position_of_include != '\"')	&&
			(*found_position_of_include != '<')	)
			continue;

		left_quote = *found_position_of_include;
		if (left_quote == '<')
			right_quote = '>';
		else
			right_quote = '\"';

		found_position_of_include++;
		/* Now the full_path_file_name is positioned between the current 	    */
		/* position pointed by found_position_of_include and the    */
		/* next occurance of right_quote.			    */

		/* Between the left quote and the filename there might be   */
		/* blanks, So, we don't need these whitespaces.		    */
		while ( isspace( *found_position_of_include ) )
			found_position_of_include++;

		/* Let file_name_ptr points to a string that contains the   */
		/* header file_name					    */
		file_name_ptr = found_position_of_include;
		while ( *found_position_of_include != right_quote)
			found_position_of_include++;
		if ( *found_position_of_include == right_quote)
			*found_position_of_include = '\0';

		/* Now, we have to trim all whitespaces following 	    */
		/* the filename.					    */
		found_position_of_include--;
		while ( isspace( *found_position_of_include ) )
		{
			*found_position_of_include = '\0';
			found_position_of_include--;
		}
		

		strcpy( son_full_path_file_name , file_name_ptr );
		if (son_full_path_file_name[0] == '\0')
		{
			printf( "\nERROR - can not find file %s in path\t%s",
				file_name_ptr,
				path_str );
		}
		else
		{
			hash_insert_file_name(h,son_full_path_file_name);
		}
	}

	tmp_el = (HASH_ELEMENT  *)hash_is_member_file_name_ptr( h, e->filename );
	if ( tmp_el != NULL )
		tmp_el->rest.local.visited = True;
	else
	{
		printf("\nUNEXPECTED ERROR occured during search for element \n\
			in HASH_TABLE , in routine file_maker\n");
		printf("\n\n");
		hash_print( h );
		exit (MMAKER_OK);
	}
	fclose(f);
	return MMAKER_OK;
}
/*--------------------------------------------------------------------------*/
int	maker_cur_dir(	HASH_TABLE	*h,
			int		file_args_num	)
{
	int		i;
	int		j;
	HASH_ELEMENT  	*tmp_el;
	char		src_file[ _MAX_PATH ];


	if (	( h == NULL ) 			||
		(file_args_num < 2)             ||
		(h->type != LOCAL_HASH_TABLE)	)
		return	BAD_PARAMETERS;

	for (i = 1; i < file_args_num; i++)
	{
		hash_init( h, LOCAL_HASH_TABLE );
		file_args_get_name( i, src_file );
		hash_insert_file_name( h, src_file );

		/* 							    */
		/* find all dependencies of current file		    */
		/* 							    */

		for ( j = 0; j < h->allocation; j++ )
		{
			tmp_el = local_static_allocation + j;
			if ( tmp_el->rest.local.visited != True)
				maker_process_entry( h , tmp_el );
		}

		/* 								   */
		/* write current file's dependencies in the makefile	    */
		/* 							    */
		if ( hash_size( h ) > 0 )
			maker_add_makefile( h , i );
	}
	maker_print_missing_files( stdout );
	return	MMAKER_OK;
}
/*--------------------------------------------------------------------------*/
int	maker_process_entry(	HASH_TABLE	*h,
				HASH_ELEMENT 	*e)
{
	HASH_ELEMENT	*g_element;

	if (	(h == NULL)			||
		(e == NULL)			||
		(h->type != LOCAL_HASH_TABLE)	)
		return	BAD_PARAMETERS;

	e->rest.local.visited = True;

	g_element = hash_is_member_file_name_ptr( &g, e->filename );
	if (g_element == NULL)
	{
		if ( hash_insert_file_name( &g, e->filename ) != ELEMENT_PRESENT)
			return ELEMENT_NOT_PRESENT;
		g_element = hash_is_member_file_name_ptr( &g, e->filename );
		if (g_element->rest.global.full_filename != PATH_INDEX_NONE)
			e->rest.local.openned = True;
	}
	if ( g_element->rest.global.full_filename != PATH_INDEX_NONE )
		e->rest.local.full_filename_ptr = &(g_element->rest.global.full_filename);
	else
		e->rest.local.full_filename_ptr = NULL;

	if (	(e->rest.local.openned == False) 		&&
		(e->rest.local.full_filename_ptr == NULL)	)
		return MMAKER_NOT_OK;

	if (	(e->rest.local.openned == False) 		||
		(e->rest.local.full_filename_ptr != NULL)	)
	{
		if (maker_file( h, e ) == MMAKER_OK)
			e->rest.local.openned = True;
	}
	return MMAKER_OK;
}
/*--------------------------------------------------------------------------*/
int	find_path_index_of_file( char  *a_file_name_ptr )
{
	static char	path_ptr[1024];
	int		i = 0;
	int		len;
	FILE		*tmp_file;

	if ( a_file_name_ptr == NULL )
		return	PATH_INDEX_NONE;

	tmp_file = fopen( a_file_name_ptr , "rt" );
	if ( tmp_file != NULL )
	{
		fclose( tmp_file );
		return	PATH_INDEX_HERE;
	}

	for (	i = 0;
		( i < MAX_PATHES_SUPPORTED ) && ( i < xxxx_pathes_counter );
		i++ )
	{
		strcpy( path_ptr , xxxx_pathes[ i ].true_name );
		len = strlen( path_ptr );
		if ( path_ptr[ len - 1 ] != PATH_SEPERATOR_CHAR )
			strcat( path_ptr , PATH_SEPERATOR_STRING );
		strcat( path_ptr , a_file_name_ptr );

		tmp_file = fopen( path_ptr , "rt" );
		if ( tmp_file != NULL )
		{
				fclose( tmp_file );
				return	i;
		}
	}

	return PATH_INDEX_NONE;
}
/*--------------------------------------------------------------------------*/
#define MAKER_PRINT_DEPENDENCY_LIST(dependency_array_param)		\
	if ( dependency_array_param[ 0 ] != '\0' )			\
	{								\
		strcpy( dependencies_copy, dependency_array_param );	\
		dep_ptr = strtok( dependencies_copy, ";" );		\
									\
		while ( dep_ptr != NULL )				\
		{							\
			fprintf(makefile,				\
				"%s%s",					\
				dependency_seperator,			\
				dep_ptr );				\
			if ( strcmp( dependency_seperator, TWO_SPACES_DEPENDENCY_SEPERATOR ) != 0 )	\
				fprintf( makefile , "\t\\");		\
									\
			dep_ptr = strtok( NULL, ";" );			\
		}							\
	}
/*--------------------------------------------------------------------------*/
#define	MAKER_SCAN_BACKWARDS_FOR_SEPERATOR				\
	tptr = a_filename + strlen( a_filename ) - 1;			\
	if ( strstr( file_args_vec[i].filename, PATH_SEPERATOR_STRING ) != NULL )\
	{								\
		while ( *tptr != PATH_SEPERATOR_CHAR )			\
			tptr--; 					\
		tptr++;							\
	}								\
	else								\
	{								\
		tptr = a_filename;					\
	}
/*--------------------------------------------------------------------------*/
void	maker_print_objests_for_link(	FILE	*outf,
					int	files,
					FILE_ARGS	file_args_vec[])
{
	int		i, j;
	char		*tptr;
	char		a_filename[ _MAX_PATH ];
	int		a_filename_len;

	for (i = 1; i < files; i++)
	{
		strcpy( a_filename , file_args_vec[ i ].filename );
		a_filename_len = strlen ( a_filename );
		for ( j = a_filename_len - 1; a_filename[ j ] != '.'; j-- )
			a_filename[ j ] = '\0';
		MAKER_SCAN_BACKWARDS_FOR_SEPERATOR
		fprintf(outf,
			"%s%s%c%s%s\t" , 
			dependency_seperator,
			compiler_output_directory,
			PATH_SEPERATOR_CHAR,
			tptr,
			output_files_extention);
		if (i < (files - 1))
			if ( strcmp(	dependency_seperator,
					TWO_SPACES_DEPENDENCY_SEPERATOR ) != 0 )
				fprintf( makefile , "\\");
	}
}
/*--------------------------------------------------------------------------*/
void	maker_print_objests_macro(	FILE	*outf,
					int	files,
					FILE_ARGS	file_args_vec[])
{
	int		i, j;
	char		*tptr;
	char		a_filename[ _MAX_PATH ];
	int		a_filename_len;

	fprintf( outf, "\nOBJECTS=" );

	for (i = 1; i < files; i++)
	{
		strcpy( a_filename, file_args_vec[ i ].filename );
		a_filename_len = strlen ( a_filename );
		for ( j = a_filename_len-1; a_filename[j] != '.'; j-- )
			a_filename[ j ] = '\0';
		MAKER_SCAN_BACKWARDS_FOR_SEPERATOR
		fprintf(outf,
			"%s%c%s%s " ,
			compiler_output_directory,
			PATH_SEPERATOR_CHAR,
			tptr,
			output_files_extention);
	}
}
/*--------------------------------------------------------------------------*/
void	maker_print_list_of_sources(	char	*alias_name,
					char	*format_a,
					char	*format_b	)
{
	int		i;


	for ( i = 1; i < file_args_num; i++ )
	{
		file_args_get_name( i, alias_name );
		if ( strstr(alias_name,PATH_SEPERATOR_STRING) == NULL )
		{
			fprintf(makefile,
				format_a,		/* "%s%c%s ",	    */
				compiler_run_directory,
				PATH_SEPERATOR_CHAR,
				alias_name );
		}
		else
		{
			fprintf(makefile,
				format_b,		/* "%s ",	    */
				alias_name );
		}
	}
}
/*--------------------------------------------------------------------------*/
	void	maker_print_source_files( char *alias_name );
/*--------------------------------------------------------------------------*/
void	maker_print_time_and_date_in_makefile( void )
{
#ifdef	BORLANDC_DOS_VERSION
	struct dosdate_t	d;
	struct dostime_t	t;
#endif
#ifdef	BORLANDC_WINDOWS_VERSION
	struct dosdate_t	d;
	struct dostime_t	t;
#endif
#ifdef	HIGHC_DOS_VERSION

	struct _dosdate_t	d;
	struct _dostime_t	t;
#endif
#ifdef	GNUC_LINUX_VERSION
	time_t			tt;
	struct tm		*tmm;
#endif


	fprintf( makefile , "#");
	MAKER_PRINT_NEWLINE_IN_MAKEFILE
	fprintf(makefile,
		"\n# Gil-ad Madar's MakeGENerator.\t\t\t\t\t version %s%c",	\
		version_number,							\
		MAKEGEN_VER_CHAR );

#ifdef	__MSDOS__
	_dos_getdate(&d);
	_dos_gettime(&t);
#else
	time( &tt );
	tmm = localtime( &tt );
#endif

	fprintf(makefile,
		"\n# DATE: %02d-%02d-%04d\t\t\t\t\t\tTIME: %02d:%02d:%02d",
#ifdef	__MSDOS__
		d.day,
		d.month,
		d.year,
		t.hour,
		t.minute,
		t.second );
#else
		tmm->tm_mday,
		tmm->tm_mon + 1,
		tmm->tm_year + 1900,
		tmm->tm_hour,
		tmm->tm_min,
		tmm->tm_sec );
#endif

	MAKER_PRINT_NEWLINE_IN_MAKEFILE
	MAKER_PRINT_NEWLINE_IN_MAKEFILE
	fprintf( makefile , "\n# automatic makefile generation for files :");
	MAKER_PRINT_NEWLINE_IN_MAKEFILE
}
/*--------------------------------------------------------------------------*/
int	maker_open_makefile(	int	file_args_num,
				FILE_ARGS	file_args_vec[])
{
	char		dependencies_copy[ MAX_PROFILE_LINE_LENGTH ];
	char		*alias_name = dependencies_copy;
  	char		*dep_ptr = NULL;

	makefile = fopen( MAKEFILE , "wt");
	if ( makefile == NULL)
	{
		printf( "\nERROR - can not open a file called \"%s\"! %s",
			MAKEFILE,
			"Using standart output.\n");
		fflush( stdout );
		makefile = stdout;
	}


	maker_print_time_and_date_in_makefile();
	maker_print_list_of_sources( alias_name, "\n#\t\t%s%c%s", "\n#\t\t%s" );
	maker_print_extra_extentions();

	MAKER_PRINT_NEWLINE_IN_MAKEFILE
	MAKER_PRINT_LINE_IN_MAKEFILE

	fprintf( makefile , "\n# LOCAL VARIABLES :");
	xxxx_macros_makefile_print( makefile );
	fprintf(makefile, "\nBASE_WD=%s", BASE_WD );
	maker_print_source_files( alias_name );

	if ( maker_control_exe == True )
		fprintf( makefile , "\nEXE_FILE=%s" , full_target_name );

	if ( maker_control_obj == True )
		maker_print_objests_macro(makefile,file_args_num,file_args_vec);

	if ( maker_control_inc == True )
		maker_print_include_path();

	if ( COMPILER_FLAGS[ 0 ] != '\0' )
		fprintf( makefile , "\nCOMPILER_FLAGS=%s" , COMPILER_FLAGS );
	if ( LINKER_FLAGS[ 0 ] != '\0' )
		fprintf( makefile , "\nLINKER_FLAGS=%s"   , LINKER_FLAGS   );

	if ( maker_control_com == True )
		fprintf( makefile , "\nCOMPILER=%s" , COMPILER );
	if ( maker_control_lin == True )
		fprintf( makefile , "\nLINKER=%s"   , LINKER   );
	MAKER_PRINT_LINE_IN_MAKEFILE
	fprintf( makefile , "\n#" );

	maker_print_user_header();

	fprintf(makefile,
		"\n%s : %s",
		(( maker_control_exe == True ) ? "$(EXE_FILE)" : full_target_name ),
		(( strcmp( dependency_seperator, TWO_SPACES_DEPENDENCY_SEPERATOR ) != 0 ) ? "\\" : TWO_SPACES_DEPENDENCY_SEPERATOR )
		);

	maker_dependency_extra_extentions();

	MAKER_PRINT_DEPENDENCY_LIST( linker_dependencies )

	maker_print_objests_for_link( makefile, file_args_num, file_args_vec );

	fprintf(makefile,
		(file_args_num > 1) ? "\n\tcd %s" : "\n\n\tcd %s",
		linker_run_directory );
	fprintf(makefile, 
		"\n\t%s\n#\n#\n#\n",
		((maker_control_lin == True) ? "$(LINKER)" : LINKER)	);

	return	MMAKER_OK;
}
/*--------------------------------------------------------------------------*/
int	maker_close_makefile(	unsigned short	params,
				char		*param[] )
{
	maker_handle_extra_extentions();
	MAKER_PRINT_LINE_IN_MAKEFILE
	MAKER_PRINT_NEWLINE_IN_MAKEFILE
	maker_print_make_depend( makefile, params, param );
	maker_print_user_footer();
	if ( maker_control_mis == True )
		maker_print_missing_files( makefile );
	fclose(makefile);
	return	MMAKER_OK;
}
/*--------------------------------------------------------------------------*/
#define	MAKER_SELECTIVE_SEPERATOR_ADD(out_str)				\
	if ( out_str[ strlen( out_str ) - 1 ] != PATH_SEPERATOR_CHAR )	\
		strcat( out_str , PATH_SEPERATOR_STRING );
/*--------------------------------------------------------------------------*/
int	maker_add_makefile(	HASH_TABLE	*h,
				int		index	)
{
	int		i, j;
	int		k;
	HASH_ELEMENT	*e;
	int		the_hash_size;
	char		a_filename[ _MAX_PATH ];
	char		out_str[ _MAX_PATH ];
	int		a_filename_len;
	unsigned short	num_of_found_files   = 0;
	unsigned short	num_of_written_files = 0;
	char		dependencies_copy[ MAX_PROFILE_LINE_LENGTH ];
  	char		*dep_ptr = NULL;
	char		*tptr;
	COMPILE_MACROS	m;

	if (	( h == NULL )			||
		( h->type != LOCAL_HASH_TABLE )	)
		return BAD_PARAMETERS;

	file_args_get_name( index, a_filename );
	a_filename_len = strlen( a_filename );
	for ( j = a_filename_len - 1; a_filename[ j ] != '.'; j-- )
		a_filename[ j ] = '\0';

	tptr = a_filename + strlen( a_filename ) - 1;
	if ( strstr( a_filename, PATH_SEPERATOR_STRING ) != NULL )
	{
		while ( *tptr != PATH_SEPERATOR_CHAR )
			tptr--;
		tptr++;
	}
	else
	{
		tptr = a_filename;
	}

	fprintf(makefile , 
		"\n%s%c%s%s : %s" , 
		compiler_output_directory,
		PATH_SEPERATOR_CHAR,
		tptr,
		output_files_extention,
		(( strcmp( dependency_seperator, TWO_SPACES_DEPENDENCY_SEPERATOR ) != 0 ) ? "\\" : TWO_SPACES_DEPENDENCY_SEPERATOR )
		);

	the_hash_size = hash_size(h);

	MAKER_PRINT_DEPENDENCY_LIST( compiler_dependencies )

	for (i = 0; i < the_hash_size; i++)
	{
		e = local_static_allocation + i;
		if ( e->rest.local.full_filename_ptr != NULL )
			num_of_found_files++;
	}

	for (i = 0; i < the_hash_size; i++)
	{
		e = local_static_allocation + i;
		if ( e->rest.local.full_filename_ptr != NULL )
		{
			num_of_written_files++;
			k = *e->rest.local.full_filename_ptr;
			if ( k == PATH_INDEX_HERE )
			{
				if ( maker_control_rel == True )
					sprintf(out_str,
						"%s%s",
						dependency_seperator,
						e->filename );
				else
				{
					sprintf(out_str,
						"%s", 
						dependency_seperator	);
					current_directory( out_str + strlen( out_str ) );
					MAKER_SELECTIVE_SEPERATOR_ADD(out_str);
					strcat( out_str, e->filename );
				}
#ifndef	MGEN_CASE_SENSITIVE_PATH
					lower_case_string( out_str );
#endif
			}
			else
			{
				if ( maker_control_use_logical_pathes == True )
				{
					sprintf(out_str,
						"%s%s",
						dependency_seperator,
						xxxx_pathes[ k ].name );
					MAKER_SELECTIVE_SEPERATOR_ADD(out_str);
					strcat( out_str, e->filename );
				}
				else
				{
					sprintf(out_str,
						"%s%s",
						dependency_seperator,
						xxxx_pathes[ k ].true_name );
					MAKER_SELECTIVE_SEPERATOR_ADD(out_str);
					strcat( out_str, e->filename );
#ifndef	MGEN_CASE_SENSITIVE_PATH
					lower_case_string( out_str );
#endif
				}
			}
			fprintf( makefile, out_str );
			if ( num_of_written_files < num_of_found_files )
				if ( strcmp( dependency_seperator, TWO_SPACES_DEPENDENCY_SEPERATOR ) != 0 )
					fprintf( makefile , "\t\\");
		}
	}

	fprintf( makefile , "\n\tcd %s" , compiler_run_directory );
	file_args_get_name( index, a_filename );
	if (maker_control_com == True)
	{
		fprintf(makefile,
			"\n\t%s %s %s",
			"$(COMPILER)",
			a_filename,
			((COMPILER_FLAGS[ 0 ] != '\0') ? "$(COMPILER_FLAGS)" : "\0" ));
	}
	else
	{
		if ( macros_expandable_in_string_count( COMPILER ) )
		{
			memset(	compiler_out, 0, MAX_CMD_LINE );
			macros_compute_compile_macros(	a_filename, &m );
			macros_expand_compile_macros( COMPILER, compiler_out, &m );
			fprintf(makefile,
				"\n\t%s",
				compiler_out );
		}
		else
		{
			fprintf(makefile,
				"\n\t%s %s %s",
				COMPILER,
				a_filename,
				((COMPILER_FLAGS[ 0 ] != '\0') ? "$(COMPILER_FLAGS)" : "\0" ));
		}
	}
	fprintf( makefile , "\n#");
	fprintf( makefile , "\n#\n");

	return	MMAKER_OK;
}
/*--------------------------------------------------------------------------*/
void	maker_print_missing_files( FILE *fileptr )
{
  	unsigned short	missing_files_num = 0;
  	unsigned short	i;

	for ( i = 0; i < g.allocation; i++ )
		if ( global_static_allocation[i].rest.global.full_filename == PATH_INDEX_NONE )
			missing_files_num++;

	if ( missing_files_num > 0 )
	{
		missing_files_num = 0;
	  	fprintf( fileptr, "\n#  The following files have not been found:"   );
	  	fprintf( fileptr, "\n#" );
		for ( i = 0; i < g.allocation; i++ )
			if ( global_static_allocation[ i ].rest.global.full_filename == PATH_INDEX_NONE )
				fprintf( fileptr, "\n# %d)\t%s",
					++missing_files_num,
					global_static_allocation[ i ].filename	);
	}
	fprintf( fileptr, "\n#" );
}
/*--------------------------------------------------------------------------*/
void	maker_print_include_path()
{
	char	*p;
	char	path_copy[ PATH_MAX_LEN ];
	char	out_str  [ PATH_MAX_LEN ];

	strcpy( path_copy, path_str );
	fprintf(makefile, "\nINCLUDE_PATH=");
	if (maker_control_flat_inc == False)
		fprintf(makefile, "\t\\");

	p = strtok( path_copy, ";" );
	while ( p != NULL )
	{
		if (maker_control_flat_inc == True)
			sprintf(out_str, "%s%s", options_inc_prefix, p );
		else
			sprintf(out_str, "\n\t\t%s%s\t\t", options_inc_prefix, p );
		fprintf(makefile, "%s", out_str );
		p = strtok( NULL, ";" );
		if (	( p != NULL )				&&
			(maker_control_flat_inc == False)	)
			fprintf(makefile, "\\" );
	}
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
void	maker_print_extra_extention_generic(	unsigned short	i,
						char		*format )
{
	char		*source;
	char		source_pattern[ _MAX_EXT + 1 ] = "*.";
	char		*end_of_p;
	char		a_filename[ _MAX_PATH ];
	DIR		*dirp;
	struct dirent	*dp;


	if ( i >= 10 )
		printf("\nParameter for extra extention # should be between 0 and 9");

	source		= extra_extentions[ i ].source;
	strcat( source_pattern, source );

	if ( (dirp = opendir( "." )) == NULL )
	{
		fprintf( stderr, "\nCannot open \".\" directory" );
		return;
	}

	while ( (dp = readdir( dirp )) != NULL )
	{
		end_of_p = source_pattern + strlen( source_pattern ) - 1;
		while ( *end_of_p != '.' )
			end_of_p--;
		end_of_p++;
#ifndef	MGEN_CASE_SENSITIVE_PATH
		if ( options_ext_match( lower_case_string( dp->d_name ),
#else
		if ( options_ext_match( dp->d_name,
#endif
							end_of_p ) == 0 )
		{
			strcpy(	a_filename, dp->d_name );
			fprintf(makefile ,
				format,
				compiler_run_directory ,
				PATH_SEPERATOR_CHAR ,
				a_filename );
		}
	}

	closedir( dirp );
}
/*--------------------------------------------------------------------------*/
void	maker_print_extra_extentions_source_files( void )
{
	unsigned short	i;
  	
	for ( i = 0; i < 10; i++ )
	{
	  	if (	(extra_extentions[ i ].target[ 0 ] != '\0')	&&
			(extra_extentions[ i ].source[ 0 ] != '\0')	&&
			(extra_extentions[ i ].command_line[ 0 ] != '\0')	)
			maker_print_extra_extention_generic( i,"%s%c%s " );
	}
}
/*--------------------------------------------------------------------------*/
void	maker_print_source_files( char *alias_name )
{
	if ( maker_control_source_files == True )
	{
		fprintf( makefile, "\nSOURCE_FILES=" );
		maker_print_list_of_sources( alias_name, "%s%c%s ", "%s " );
		maker_print_extra_extentions_source_files();
	}
}
/*--------------------------------------------------------------------------*/
void	maker_print_make_depend(FILE		*fileptr,
				unsigned short	params,
				char		*param[]	)
				
{
	int	i;

	if ( maker_control_make_depend == True )
	{
		fprintf( fileptr, "\ndepend:\n\t" );
#ifdef	HIGHC_DOS_VERSION
		fprintf( fileptr, "run386 " );
#endif
		for ( i = 0; i < params; i++ )
			fprintf( fileptr, "%s ",
#ifndef	MGEN_CASE_SENSITIVE_PATH
				lower_case_string( param[ i ] ) );
#else
				param[ i ] );
#endif
		fprintf( fileptr, "\n\n#--------------------------------------------------------------------------");
	}
}
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
