/*
 * maker.h           -	This file is part of the MakeGENerator program, a
 *			programmers' utility for automatic generation of
 *			makefiles.
 *
 * Copyright (C) 1997 Gil-ad Madar
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *   Author: Gil-ad Madar
 *   e-mail: gil-ad@inter.net.il
 */

#ifndef	MAKER__H
#define	MAKER__H

#include "hash.h"
#include "vars.h"
/*--------------------------------------------------------------------------*/
void	maker_print_user_header( void );
void	maker_print_user_footer( void );
void	maker_dependency_extra_extention( unsigned short	i  );
void	maker_dependency_extra_extentions( void );
void	maker_handle_extra_extention( unsigned short	i  );
void	maker_handle_extra_extentions( void );
int     maker_create_makefile(	HASH_TABLE	*h,
				int		file_args_num,
				FILE_ARGS	file_args_vec[]);
int	maker_add_makefile(	HASH_TABLE	*h,
				int		file_args_num );
int	maker_open_makefile(	int		file_args_num,
				FILE_ARGS	file_args_vec[]);

int	maker_close_makefile( unsigned short params, char *param[] );

int	maker_file(	HASH_TABLE	*h,
			HASH_ELEMENT	*e);
int	maker_process_entry(	HASH_TABLE	*h,
				HASH_ELEMENT	*e);
int	maker_cur_dir(	HASH_TABLE	*h,
			int		file_args_num	);
/*--------------------------------------------------------------------------*/
char	*find_path_of_file( char *a_file_name_ptr );
int	find_path_index_of_file( char *a_file_name_ptr );
char	*current_directory(char *cur_dir);
char	*lower_case_string(char	*str);
void	maker_print_missing_files( FILE *fileptr );
void	maker_print_include_path( void );
void	maker_print_make_depend(FILE		*fileptr,
				unsigned short	params,
				char		*param[]	);
/*--------------------------------------------------------------------------*/
#endif		/*#ifndef	MAKER__H*/
