/*
 * vars.h            -	This file is part of the MakeGENerator program, a
 *			programmers' utility for automatic generation of
 *			makefiles.
 *
 * Copyright (C) 1997 Gil-ad Madar
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 2 of the License.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *   Author: Gil-ad Madar
 *   e-mail: gil-ad@inter.net.il
 */

#ifndef VARS__H
#define VARS__H

#ifdef	VARS__C
#define EXTERN
#else
#define EXTERN	extern
#endif

/*--------------------------------------------------------------------------*/
typedef struct
{
  	char	target		[ _MAX_EXT - 1 ];
  	char	source		[ _MAX_EXT - 1 ];
	char	command_line	[ MAX_CMD_LINE ];
}	EXTRA_EXTENTIONS;
/*--------------------------------------------------------------------------*/
typedef struct
{
	char	*path;
	char	filename[ MAX_FILE_NAME ];
}	FILE_ARGS;
/*--------------------------------------------------------------------------*/
EXTERN	HASH_ELEMENT	global_static_allocation[ HASH_MAX_STATIC_ALLOCATION ];
EXTERN	HASH_ELEMENT	local_static_allocation [ HASH_MAX_STATIC_ALLOCATION ];
/*--------------------------------------------------------------------------*/
EXTERN	FILE_ARGS		file_args_vec[ MAX_FILES ];
EXTERN	unsigned short		file_args_num;
EXTERN	EXTRA_EXTENTIONS	extra_extentions[ 10 ];
EXTERN	char			path_str[ PATH_MAX_LEN ];
EXTERN	HASH_TABLE		h;
EXTERN	HASH_TABLE		g;
/*--------------------------------------------------------------------------*/
/*--------------------------------------------------------------------------*/
#ifdef VARS__C
/*--------------------------------------------------------------------------*/
	unsigned short	maker_base_wd			= BASE_WD_IS_UWD;
	unsigned short	maker_max_lines			= 0;
	unsigned short	maker_control_bwd		= False;
	unsigned short	maker_control_exe		= False;
	unsigned short	maker_control_obj		= False;
	unsigned short	maker_control_inc		= False;
	unsigned short	maker_control_com		= False;
	unsigned short	maker_control_lin		= False;
	unsigned short	maker_control_rel		= False;
	unsigned short	maker_control_mis		= False;
	unsigned short	maker_control_source_files	= False;
	unsigned short	maker_control_make_depend	= False;
	unsigned short	maker_control_flat_path_str	= False;
	unsigned short	maker_control_flat_linker	= False;
	unsigned short	maker_control_flat_compiler	= False;
	unsigned short	maker_control_flat_Dependencies	= False;
	unsigned short	maker_control_flat_dependencies	= False;
	unsigned short	maker_control_flat_inc		= False;
	unsigned short	maker_control_flat_files_selection = False;
	unsigned short	maker_control_use_logical_pathes= False;

	char	version_number			[ 10 ]           = "3.65";
	char	options_target_name		[ _MAX_PATH    ] = "";
	char	options_inc_prefix		[ 10 ]		 = "";
	char	MAKEFILE			[ _MAX_PATH    ] = "Makefile";
	char	LINKER				[ MAX_LIB_CMD_LINE ] =
#ifndef	GNUC_LINUX_VERSION
	"lib";
#else
	"gcc $(OBJECTS) -o $< ";
#endif
	char	COMPILER			[ MAX_LIB_CMD_LINE ] = 
#ifndef	GNUC_LINUX_VERSION
	"ce";
#else
	"gcc -c -g";
#endif
	char	LINKER_FLAGS			[ MAX_CMD_LINE ] = "";
	char	COMPILER_FLAGS			[ MAX_CMD_LINE ] = "";
	char	linker_dependencies		[ MAX_PROFILE_LINE_LENGTH ] = "";
	char	compiler_dependencies		[ MAX_PROFILE_LINE_LENGTH ] = "";
	char	BASE_WD				[ _MAX_PATH    ] = "..";
	char	base_wd_string			[ _MAX_PATH    ] = "";

	char	base_working_directory		[ _MAX_PATH ] = "";
	char	full_target_name		[ _MAX_PATH ] = "";
	char	linker_output_directory 	[ _MAX_PATH ] = "";
	char	linker_run_directory		[ _MAX_PATH ] = "";
	char	compiler_output_directory	[ _MAX_PATH ] = "";
	char	compiler_run_directory		[ _MAX_PATH ] = "";
	char	files_selection			[ MAX_FILES_SELECTION ] = "*.c";
	char	options_user_header_filename	[ _MAX_PATH ] = "";
	char	options_user_footer_filename	[ _MAX_PATH ] = "";
	char	dependency_seperator		[ _MAX_PATH ] = NEWLINE_TAB_TAB_DEPENDENCY_SEPERATOR;
	char	output_files_extention		[ _MAX_EXT  ] =	"obj";
/*--------------------------------------------------------------------------*/
#else
/*--------------------------------------------------------------------------*/
	extern	unsigned short	maker_base_wd	 ;
	extern	unsigned short	maker_max_lines  ;
	extern	unsigned short	maker_control_bwd;
	extern	unsigned short	maker_control_exe;
	extern	unsigned short	maker_control_obj;
	extern	unsigned short	maker_control_inc;
	extern	unsigned short	maker_control_com;
	extern	unsigned short	maker_control_lin;
	extern	unsigned short	maker_control_rel;
	extern	unsigned short	maker_control_mis;
	extern	unsigned short	maker_control_source_files;
	extern	unsigned short	maker_control_make_depend;
	extern	unsigned short	maker_control_flat_path_str;
	extern	unsigned short	maker_control_flat_linker;
	extern	unsigned short	maker_control_flat_compiler;
	extern	unsigned short	maker_control_flat_Dependencies;
	extern	unsigned short	maker_control_flat_dependencies;
	extern	unsigned short	maker_control_flat_inc;
	extern	unsigned short	maker_control_flat_files_selection;
	extern	unsigned short	maker_control_use_logical_pathes;

	extern	char	version_number			[];
	extern	char	options_target_name		[];
	extern	char	options_inc_prefix		[];
	extern	char	MAKEFILE			[];
	extern	char	LINKER				[];
	extern	char	COMPILER			[];
	extern	char	LINKER_FLAGS			[];
	extern	char	COMPILER_FLAGS			[];
	extern	char	linker_dependencies		[];
	extern	char	compiler_dependencies		[];
	extern	char	BASE_WD				[];
	extern	char	base_wd_string			[];

	extern	char	base_working_directory		[];
	extern	char	full_target_name		[];
	extern	char	linker_output_directory 	[];
	extern	char	linker_run_directory		[];
	extern	char	compiler_output_directory	[];
	extern	char	compiler_run_directory		[];
	extern	char	files_selection			[];
	extern	char	output_files_extention		[];
	extern	char	options_user_header_filename	[];
	extern	char	options_user_footer_filename	[];
	extern	char	dependency_seperator		[];
/*--------------------------------------------------------------------------*/
#endif
/*--------------------------------------------------------------------------*/

#undef	EXTERN
#endif		/* #ifndef VARS__H					    */
